
var BerUI = require("../../index");
var Canvas = require("./Canvas");

// ====

var CanvasCheck = (function() {
    //

    //
    class CanvasCheck extends Canvas {
        constructor(parentView, options, scrollPanel) { // NOTE: 當作為 list 的 item 時, 用 scrollPanel.isScrolling 確保 touch 相關事件的捲動檢查運作正常
            super(parentView, options);
            var _this = this;
            var target;

            this.checked = false;


            // == ui ==

            // NOTE: 初始化狀態相關的參數
            if(this.look.value.src) {
                this.look.normalSrc = this.look.value.src;
            }
            if(this.look.value.src_active) {
                this.look.activeSrc = this.look.value.src_active;
            }


            // == methods ==
            function setState(checked) {
                _this.checked = checked;
                if(_this.checked) {
                    setBtnColor(true);
                } else {
                    setBtnColor(false);
                }
            }
            function switchState() {
                _this.checked = !_this.checked;
                if(_this.checked) {
                    setBtnColor(true);
                } else {
                    setBtnColor(false);
                }
            }
            function setBtnColor(active) {
                if(active) {
                    _this.look.value.src = _this.look.activeSrc;
                } else {
                    _this.look.value.src = _this.look.normalSrc;
                }
                _this.redrawLook();
            }

            function onTouchStart(event) {
                if(_this.opts.disabled) return;
                //
                target = event.target;
            }
            function onTouchMove(event) {
                if(_this.opts.disabled) return;
                //
                if(scrollPanel && scrollPanel.isScrolling) {
                    console.log("yo");
                    return;
                }
                //
                var moveTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target !== moveTarget) { // NOTE leave
                    target = null;
                }
            }
            function onTouchEnd(event) {
                if(_this.opts.disabled) return;
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        switchState();
                        _this.emit("itemClicked", _this.canvas.Value);
                    }
                }

            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgNormal }); // TODO add EnterStyle
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
            }
            function onClick() {
                if(_this.opts.disabled) return;
                switchState();
                _this.emit("itemClicked", _this.canvas.Value);
            }


            // == events ==
            if("ontouchstart" in window) {
                this.canvas.domOn("touchstart", onTouchStart, false);
                this.canvas.domOn("touchmove", onTouchMove, false);
                this.canvas.domOn("touchend", onTouchEnd, false);
            } else {
                this.canvas.domOn("mousedown", onMouseDown);
                this.canvas.domOn("mouseenter", onMouseEnter);
                this.canvas.domOn("mouseleave", onMouseLeave);
                this.canvas.domOn("mouseup", onMouseUp);
                this.canvas.domOn("click", onClick);
            }

        }

        init() {
            super.init();

            //
            this.look.value.src = "";
            this.look.value.src_active = "";
            this.look.value.bgColor = BerColor.Transparent;
            //
            // this.look.value.padding = 2;
            // this.look.value.borderRadius = 4;

            // for btn (不需要讓外部設定)
            this.look.value.normalSrc = this.look.value.src;
            this.look.value.activeSrc = this.look.value.src_active;

            //
            this.canvas.setOpts({ cursor: "pointer" });

        }

        setLook(look, setOnly) {
            if(look.value) {
                if(look.value.src) this.look.value.normalSrc = look.value.src;
                if(look.value.src_active) this.look.value.activeSrc = look.value.src_active;
            }
            super.setLook(look, setOnly);
        }

        set Checked(checked) {
            this.setState(checked);
        }
        get Checked() {
            return this.checked;
        }

    }


    //
    return CanvasCheck;
})();


//
module.exports = CanvasCheck;
