
var BerUI = require("../../index");
var Canvas = require("./Canvas");

// ====

var CanvasSwitch = (function() {
    //

    //
    class CanvasSwitch extends Canvas {
        constructor(parentView, options, scrollPanel) { // NOTE: 當作為 list 的 item 時, 用 scrollPanel.isScrolling 確保 touch 相關事件的捲動檢查運作正常
            super(parentView, options);
            var _this = this;
            var target;

            this.checked = false;


            // == ui ==
            if(this.look.value.normalSrc) {
                this.look.value.src = this.look.value.normalSrc;
            }


            // == methods ==
            function setState(checked) {
                _this.checked = checked;
                if(_this.checked) {
                    setBtnColor(true);
                } else {
                    setBtnColor(false);
                }
            }
            function switchState() {
                _this.checked = !_this.checked;
                if(_this.checked) {
                    setBtnColor(true);
                } else {
                    setBtnColor(false);
                }
            }
            function setBtnColor(active) {

                // TODO: dev ing

                if(active) {
                    // _this.look.bgColor = _this.look.value.activeColor;
                    _this.container.setLook({ bgColor: _this.look.value.activeColor });
                    _this.look.value.src = _this.look.value.activeSrc;
                    _this.cellValue.animate({
                        duration: 100,
                        transform: { translateX: (_this.PxW - _this.cellValue.PxW) }
                    });

                } else {
                    // _this.look.bgColor = _this.look.value.normalColor;
                    _this.container.setLook({ bgColor: _this.look.value.normalColor });
                    _this.look.value.src = _this.look.value.normalSrc;
                    _this.cellValue.animate({
                        duration: 100,
                        transform: { translateX: 0 }
                    });

                }
                _this.redrawLook();
            }

            function onTouchStart(event) {
                if(_this.opts.disabled) return;
                //
                target = event.target;
            }
            function onTouchMove(event) {
                if(_this.opts.disabled) return;
                //
                var moveTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target !== moveTarget) { // NOTE leave
                    target = null;
                }
            }
            function onTouchEnd(event) {
                if(_this.opts.disabled) return;
                //
                if(scrollPanel && scrollPanel.isScrolling) {
                    console.log("yo");
                    return;
                }
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        switchState();
                        _this.emit("itemClicked", _this.canvas.Value);
                    }
                }

            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgNormal }); // TODO add EnterStyle
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
            }
            function onClick() {
                if(_this.opts.disabled) return;
                switchState();
                _this.emit("itemClicked", _this.canvas.Value);
            }

            //
            this.setState = setState;


            // == events ==
            if("ontouchstart" in window) {
                this.domOn("touchstart", onTouchStart, false);
                this.domOn("touchmove", onTouchMove, false);
                this.domOn("touchend", onTouchEnd, false);
            } else {
                this.domOn("mousedown", onMouseDown);
                this.domOn("mouseenter", onMouseEnter);
                this.domOn("mouseleave", onMouseLeave);
                this.domOn("mouseup", onMouseUp);
                this.domOn("click", onClick);
            }

        }

        init() {
            super.init();

            //
            this.look.value.activeColor = BerColor.BtnText;
            this.look.value.normalColor = BerColor.BtnBg;
            this.look.value.activeSrc = "";
            this.look.value.normalSrc = "";
            this.look.value.bgColor = "white";
            this.look.value.canvasPadding = 6;
            // this.look.value.padding = 2;
            // this.look.value.borderRadius = 4;


            // ====

            var container = new BerUI.BasePanel(this, {
                look: { bgColor: this.look.value.normalColor },
                opts: { cursor: "pointer" }
            });

            this.cellValue.setParentView(container);
            this.canvas.setOpts({ cursor: "pointer" });

            //
            this.container = container;

        }

        redrawRect() {
            super.redrawRect();

            this.cellValue.setRect({
                w: this.container.PxH + "px"
            });

            var borderRadius = this.container.PxH / 2; console.log(this.container.PxH);
            this.container.setLook({
                borderRadius: borderRadius
            });
            this.cellValue.setLook({
                borderRadius: borderRadius
            });


        }

        set Checked(checked) {
            this.setState(checked);
        }
        get Checked() {
            return this.checked;
        }

    }


    //
    return CanvasSwitch;
})();


//
module.exports = CanvasSwitch;
