
var BerUI = require("../../index");
var TextBox = require("./TextBox");
var DropdownPanel = require("./DropdownPanel");

// ====

var DropdownBox = (function() {
    //

    //
    class DropdownBox extends TextBox {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==
            var dropdownPanel = new DropdownPanel(BerRoot, {
                opts: {
                    visible: false,
                    mode: _this.look.dropdown.mode || _this.opts.mode
                }
            });


            // == methods ==
            function loadList(dataList) {
                _this.dataList = dataList;
            }
            function showList() {
                var itemsLook = {
                    value: {
                        txtColor: _this.look.value.txtColor,
                        bgColor: _this.look.value.bgColor,
                        txtAlign: "left",
                    }
                };
                dropdownPanel.setLook({ maxRows: _this.look.dropdown.maxVisibleRows });
                dropdownPanel.show(_this.frameValue, itemsLook, _this.dataList);
            }
            //
            this.loadList = loadList;
            this.showList = showList;


            // == events ==
            dropdownPanel.on("itemClicked", function(data, index, itemID) {
                // console.log(data, index, itemID);

                _this.Data = data;
                // NOTE: 因應兩種設定方式, 所以 data 會有兩種格式. 但 emit 出去同一種.
                if(typeof data.value == "string") {
                     _this.Value = data.value;
                     _this.emit("dropdownClicked", data, index, itemID);
                } else {
                    _this.Value = data.value.value.txt;
                    _this.emit("dropdownClicked", { value: data.value.value.txt }, index, itemID);
                }

                dropdownPanel.hide();
            });


            // == box event ==
            var target;
            function onTouchStart() {
                if(_this.opts.disabled) return;
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        onClick();
                    }
                }
            }
            function onClick() {
                // findthis
                if(_this.opts.disabled) return;
                _this.emit("itemClicked", _this.tbValue.Value);
                showList();
            }
            //
            if("ontouchstart" in window) {
                this.tbValue.domOn("touchstart", onTouchStart, false);
                this.tbValue.domOn("touchmove", onTouchMove, false);
                this.tbValue.domOn("touchend", onTouchEnd, false);
            } else {
                this.tbValue.domOn("click", onClick);
            }

        }

        init() {
            super.init();

            //
            this.dataList = []; // { value: "這個會顯示為按鈕文字" }

            //
            this.look.dropdown = {
                maxVisibleRows: 5,
                mode: null,
            };

            this.opts.mode = null;


        }

        //
        set Value(val) {
            super.Value = val;
        }
        get Value() {
            return super.Value;
        }

        set Data(data) {
            this.data = data;
            if(data.value) this.Value = data.value;
        }
        get Data() {
            return this.data;
        }


    }


    //
    return DropdownBox;
})();


//
module.exports = DropdownBox;
