
var BerUI = require("../../index");
var Text = require("./Text");

// ====

var Switch = (function() {
    //

    //
    class Switch extends Text {
        constructor(parentView, options, scrollPanel) { // NOTE: 當作為 list 的 item 時, 用 scrollPanel.isScrolling 確保 touch 相關事件的捲動檢查運作正常
            super(parentView, options);
            var _this = this;
            var target;

            this.checked = false;


            // == ui ==


            // == methods ==
            function setState(checked) {
                _this.checked = checked;
                if(_this.checked) {
                    setBtnColor(true);
                } else {
                    setBtnColor(false);
                }
            }
            function switchState() {
                _this.checked = !_this.checked;
                if(_this.checked) {
                    setBtnColor(true);
                } else {
                    setBtnColor(false);
                }
            }
            function setBtnColor(active) {
                //
                if(active) {
                    _this.container.setLook({ bgColor: _this.look.value.activeColor });
                    _this.cellValue.animate({
                        duration: 100,
                        transform: { translateX: (_this.container.PxW / 2) }
                    });

                } else {
                    _this.container.setLook({ bgColor: _this.look.value.normalColor });
                    _this.cellValue.animate({
                        duration: 100,
                        transform: { translateX: 0 }
                    });

                }
                // TODO: 切換文字
                // _this.txtValue.setLook({
                //     bgColor: _this.look.value.bgColor,
                //     txtColor: _this.look.value.txtColor,
                // });

            }

            function onTouchStart(event) {
                if(_this.opts.disabled) return;
                //
                target = event.target;
            }
            function onTouchMove(event) {
                if(_this.opts.disabled) return;
                //
                var moveTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target !== moveTarget) { // NOTE leave
                    target = null;
                }
            }
            function onTouchEnd(event) {
                if(_this.opts.disabled) return;
                //
                if(scrollPanel && scrollPanel.isScrolling) {
                    console.log("yo");
                    return;
                }
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        switchState();
                        _this.emit("itemClicked", _this.txtValue.Value, _this.checked);
                    }
                }

            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgNormal }); // TODO add EnterStyle
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
            }
            function onClick() {
                if(_this.opts.disabled) return;
                switchState();
                _this.emit("itemClicked", _this.txtValue.Value, _this.checked);
            }

            //
            this.setState = setState;


            // == events ==
            if("ontouchstart" in window) {
                this.domOn("touchstart", onTouchStart, false);
                this.domOn("touchmove", onTouchMove, false);
                this.domOn("touchend", onTouchEnd, false);
            } else {
                this.domOn("mousedown", onMouseDown);
                this.domOn("mouseenter", onMouseEnter);
                this.domOn("mouseleave", onMouseLeave);
                this.domOn("mouseup", onMouseUp);
                this.domOn("click", onClick);
            }

            // NOTE: 有非常多地方可以套用這種方式來節省無謂的 redraw. // TODO: 到處去優化 >> 啊阿 需要規劃一下
            var resizeTaskId;
            window.addEventListener("resize", evt => {
                if(resizeTaskId !== null) {
                    clearTimeout(resizeTaskId);
                }

                resizeTaskId = setTimeout(() => {
                    resizeTaskId = null;

                    if(_this.checked) {
                        _this.cellValue.animate({
                            duration: 100,
                            transform: { translateX: (_this.container.PxW / 2) }
                        });

                    } else {
                        _this.cellValue.animate({
                            duration: 100,
                            transform: { translateX: 0 }
                        });

                    }

                }, 100);

            });


        }

        init() {
            super.init();

            //
            this.look.value.activeColor = BerColor.BtnText;
            this.look.value.normalColor = BerColor.BtnBg;

            // this.look.value.txt = "";
            this.look.value.txtColor = "rgb(80, 80, 80)";//BerColor.BtnText;
            this.look.value.bgColor = "white";//BerColor.BtnBg;
            this.look.value.txtAlign = "center";
            // this.look.value.txtScale = 0.4;
            //
            // this.look.value.padding = 2;
            this.look.value.borderRadius = 4;


            // ====

            var container = new BerUI.BasePanel(this, {
                look: { bgColor: this.look.value.normalColor },
                opts: { cursor: "pointer" }
            });

            this.cellValue.setParentView(container);
            this.cellValue.setRect({ w: 50 });

            this.txtValue.setOpts({ cursor: "pointer" });


            //
            this.container = container;

        }

        redrawLook() {
            super.redrawLook();

            this.container.setLook({
                borderRadius: this.look.value.borderRadius
            });

        }

        set Checked(checked) {
            this.setState(checked);
        }
        get Checked() {
            return this.checked;
        }


    }


    //
    return Switch;
})();


//
module.exports = Switch;
