
var BerUI = require("../../index");

// ====

var TextBox = (function() {
    //

    //
    class TextBox extends BerUI.BasePanel {
        constructor(parentView, options, itemData) {
            super(parentView, options);
            var _this = this;


            // == ui ==


            // == methods ==

            function focus() {
                _this.tbValue.focus();
            }
            function blur() {
                _this.tbValue.blur();
            }
            function select() {
                _this.tbValue.select();
            }
            //
            this.focus = focus;
            this.blur = blur;
            this.select = select;


            // == events ==
            this.tbValue.on("change", function(val) {
                _this.emit("change", val);
            });
            this.tbValue.on("input", function(val) {
                _this.look.value.txt = _this.core.value;
                _this.emit("input", val);
            });
            this.tbValue.on("focus", function() {
                _this.emit("focus");
            });
            this.tbValue.on("blur", function() {
                _this.emit("blur");
            });

        }

        init() {
            super.init();

            //
            this.look.value = {
                txt: "",
                txtColor: BerColor.Darker,
                bgColor: "white",
                txtAlign: "left",
                txtScale: 0.4,

                placeholder: "",

                padding: 2,
                borderRadius: 4,

                frameSize: 2,
                frameColor: "white",

            };

            this.opts.value = {
                textType: "string",
                readonly: false,
            }


            // == ui ==
            var cellValue = new BerUI.BasePanel(this);
            var frameValue = new BerUI.BasePanel(cellValue);
            var tbValue = new BerUI.TextBoxView(frameValue, {
                opts: {
                    cursor: "text"
                }
            });


            //
            this.cellValue = cellValue;
            this.frameValue = frameValue;
            this.tbValue = tbValue;

        }

        redrawLook() {
            super.redrawLook();

            var valueLook = this.look.value;

            this.cellValue.setLook({
                padding: valueLook.padding
            });

            this.frameValue.setLook({
                bgColor: valueLook.frameColor,
                borderRadius: valueLook.borderRadius,
                padding: valueLook.frameSize,
            });

            this.tbValue.setLook({
                bgColor: valueLook.bgColor,
                txtColor: valueLook.txtColor,
                txtScale: valueLook.txtScale,
                txtAlign: valueLook.txtAlign,
                txt: valueLook.txt,
                placeholder: valueLook.placeholder
            });

        }

        redrawOpts() {
            super.redrawOpts();

            var valueOpts = this.opts.value;

            this.tbValue.setOpts({
                textType: valueOpts.textType,
                readonly: valueOpts.readonly
            });

        }

        //
        set Value(val) {
            this.look.value.txt = val;
            this.tbValue.Value = val;
        }
        get Value() {
            return this.tbValue.Value;
        }

        //
        setFrameColor(color) {
            this.setLook({
                value: {
                    frameColor: color
                }
            })
        }

    }

    //
    return TextBox;
})();


// ====
module.exports = TextBox;
