
var BerUI = require("../index");

// ====

var CheckPanel = (function() {
    //

    //
    class CheckPanel extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            var target;
            var checked = false;


            // == ui ==
            // this.txtTitle.Value = this.look.title;
            this.txtValue.setLook({
                bgColor: this.look.normalBgColor,
                txtColor: this.look.activeBgColor,
                txt: this.look.value
            });


            // == methods ==
            function onTouchStart(event) {
                if(_this.opts.disabled) return;
                //
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                //
                var moveTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target !== moveTarget) { // NOTE leave
                    _this.txtValue.setLook({
                        bgColor: _this.look.normalBgColor,
                        txtColor: _this.look.activeBgColor
                    });
                    target = null;
                }
            }
            function onTouchEnd(event) {
                if(_this.opts.disabled) return;
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        checked = !checked;
                        if(checked) {
                            _this.txtValue.setLook({
                                bgColor: _this.look.activeBgColor,
                                txtColor: _this.look.normalBgColor
                            });
                        } else {
                            _this.txtValue.setLook({
                                bgColor: _this.look.normalBgColor,
                                txtColor: _this.look.activeBgColor
                            });
                        }

                        //
                        _this.emit("itemChecked", _this.txtValue.Value, checked);
                    }
                }


            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgActive });
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgNormal }); // TODO add EnterStyle
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgNormal });
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
                // _this.txt.setLook({ bgColor: _this.look.bgNormal });
            }
            function onClick() {
                if(_this.opts.disabled) return;
                checked = !checked;
                if(checked) {
                    _this.txtValue.setLook({
                        bgColor: _this.look.activeBgColor,
                        txtColor: _this.look.normalBgColor
                    });
                } else {
                    _this.txtValue.setLook({
                        bgColor: _this.look.normalBgColor,
                        txtColor: _this.look.activeBgColor
                    });
                }
                _this.emit("itemChecked", _this.txtValue.Value, checked);
            }


            // == events ==
            if("ontouchstart" in window) {
                this.txtValue.domOn("touchstart", onTouchStart, false);
                this.txtValue.domOn("touchmove", onTouchMove, false);
                this.txtValue.domOn("touchend", onTouchEnd, false);
            } else {
                this.txtValue.domOn("mousedown", onMouseDown);
                this.txtValue.domOn("mouseenter", onMouseEnter);
                this.txtValue.domOn("mouseleave", onMouseLeave);
                this.txtValue.domOn("mouseup", onMouseUp);
                this.txtValue.domOn("click", onClick);
            }



            // //
            // setTimeout(function() {
            //     _this.redraw(true);
            // }, 100);

        }


        // == init ==
        init() {
            super.init();

            // extends
            this.look.normalBgColor = BerColor.Brighter;
            this.look.activeBgColor = BerColor.BtnBright;
            this.look.title = "----";
            this.look.value = "----";


            // == ui ==
            var panel = new BerUI.BasePanel(this, {
                look: { padding: 2 }
            });

            // var cellTitle = new BerUI.BasePanel(panel, {
            //     rect: { h: 30 },
            //     look: { padding: 5 }
            // });
            // var txtTitle = new BerUI.TextView(cellTitle, {
            //     look: {
            //         txtColor: BerColor.Mid,
            //         txtScale: 0.9,
            //         txtAlign: "left",
            //         txt: this.look.title
            //     }
            // });

            var cellValue = new BerUI.BasePanel(panel, {
                // rect: { y: 30, h: 70 },
                look: { padding: 2 }
            });
            var txtValue = new BerUI.TextView(cellValue, {
                look: {
                    borderRadius: 4,
                    bgColor: this.look.normalBgColor,
                    txtColor: BerColor.Dark,
                    txtScale: 0.4,
                    txtAlign: "center",
                    txt: this.look.value
                }
            });

            //
            // this.txtTitle = txtTitle;
            this.txtValue = txtValue;

        }


    }


    //
    return CheckPanel;
})();


//
module.exports = CheckPanel;
