
var BerUI = require("../index");
var SimpleBtn = require("./SimpleBtn");

// ====

var ConfirmPanel = (function() {
    //

    //
    class ConfirmPanel extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==


            // == events ==
            this.domOn("click", function() {
                _this.hide();
            });
            this.boxPanel.domOn("click", function() {
                // do nothing (只是為了吃掉事件)
            });
            this.btnLeft.on("clicked", function(btn) {
                // console.log("[back]", btn);
                _this.emit("result", false);
                _this.hide();
            });
            this.btnRight.on("clicked", function(btn) {
                // console.log("[done]", btn);
                _this.cbDone();
                _this.emit("result", true);
                _this.hide();
            });

        }


        // == init ==
        init() {
            super.init();

            this.opts.visible = false;

            // look
            this.look.bgColor = BerColor.TrasparentDark;


            // == ui ==
            var UNIT_H = 18;

            var boxPanel = new BerUI.BasePanel(this, {
                rect: { x: 15, y: 25, w: 70, h: 50 },
                look: {
                    borderRadius: 4,
                    bgColor: BerColor.Brighter
                }
            });


            // msg
            var msgPanel = new BerUI.BasePanel(boxPanel, {
                rect: { h: (100 - UNIT_H* 1.5) }
                // look: { padding: 4 }
            });

            var txtSingle = new BerUI.TextView(msgPanel, {
                rect: { y: 25, h: 50 },
                look: {
                    txtColor: BerColor.Dark,
                    txtAlign: "center",
                    txtScale: 0.3
                }
            });
            var txtDoubleTitle = new BerUI.TextView(msgPanel, {
                rect: { y: 10, h: 40 },
                look: {
                    txtColor: BerColor.Dark,
                    txtAlign: "center",
                    txtScale: 0.3
                }
            });
            var txtDoubleMsg = new BerUI.TextView(msgPanel, {
                rect: { y: 50, h: 40 },
                look: {
                    txtColor: BerColor.Dark,
                    txtAlign: "center",
                    txtScale: 0.3
                }
            });

            // btn
            var btnPanel = new BerUI.BasePanel(boxPanel, {
                rect: { y: (100 - UNIT_H * 1.5), h: UNIT_H }
            });
            var btnLeft = new SimpleBtn(btnPanel, {
                rect: { w: 50 },
                look: {
                    bgNormal: BerColor.Brighter,
                    bgActive: BerColor.Mid,
                    txtColor: BerColor.BtnBright,
                    txt: "返回"
                }
            });
            var btnRight = new SimpleBtn(btnPanel, {
                rect: { x: 50, w: 50 },
                look: {
                    bgNormal: BerColor.Brighter,
                    bgActive: BerColor.Mid,
                    txtColor: BerColor.BtnBright,
                    txt: "確定"
                }
            });


            //
            this.boxPanel = boxPanel;

            this.txtSingle = txtSingle;
            this.txtDoubleTitle = txtDoubleTitle;
            this.txtDoubleMsg = txtDoubleMsg;

            this.btnLeft = btnLeft;
            this.btnRight = btnRight;


        }


        // ====
        show(data, callback) {
            super.show();

            this.cbDone = callback;

            if(isUsable(data.title)) {
                this.txtDoubleTitle.Value = data.title;
                this.txtDoubleMsg.Value= data.msg;
                this.txtSingle.setOpts({ visible: false });
                this.txtDoubleTitle.setOpts({ visible: true });
                this.txtDoubleMsg.setOpts({ visible: true });
            } else {
                this.txtSingle.Value = data.msg;
                this.txtSingle.setOpts({ visible: true });
                this.txtDoubleTitle.setOpts({ visible: false });
                this.txtDoubleMsg.setOpts({ visible: false });
            }

        }


    }


    //
    return ConfirmPanel;
})();


//
module.exports = ConfirmPanel;
