
var TextBoxRow = CusUI.TextBoxRow;
var SetPanel = CusUI.SetPanel;
var GenericPicker = CusUI.GenericPicker;
var GridFuncPanel = CusUI.GridFuncPanel;

// ====

var ImportSearchPanel = (function() {
    //
    var itemSettings = [
        [{
            id: "code",
            type: "textbox",
            title: "條碼"
        }],

        [{
            id: "name",
            type: "text",
            title: "名稱",
            widthWeight: 3
        }, {
            id: "stock",
            type: "text",
            title: "存貨"
        }, {
            id: "sold",
            type: "text",
            title: "售出"
        }, {
            id: "total",
            type: "text",
            title: "總數"
        }],

        [{
            id: "invi_0",
            type: "setPanel",
            title: "",
            value: "",
            options: { opts: { visible: false } },
        }, {
            id: "invi_1",
            type: "setPanel",
            title: "",
            value: "",
            options: { opts: { visible: false } },
        }, {
            id: "reset",
            type: "setPanel",
            title: "",
            value: "重置"
        }, {
            id: "search",
            type: "setPanel",
            title: "",
            value: "搜尋"
        }],

    ];

    //
    class ImportSearchPanel extends GridFuncPanel {
        constructor(parentView, options) {
            super(parentView, options, itemSettings);
            var _this = this;


            // == ui ==


            // == methods ==
            function search(data) {
                var _data = {};
                if(data) {
                    _data = data;
                    _this.Code = (_data.code ? _data.code : "");
                    _this.Name = (_data.name ? _data.name : "");
                } else {
                    if(_this.Code) _data.code = _this.Code;
                    if(_this.Name) _data.name = _this.Name;
                }

                _this.emit("search", _data);

            }

            //
            this.search = search;


            // == events ==
            this.items.reset.on("itemClicked", function() {
                _this.Code = "";
                _this.Name = "";
                _this.Stock = 0;
                _this.Sold = 0;
                _this.Total = 0;
                _this.emit("reset");
            });
            this.items.search.on("itemClicked", function() {
                search();
            });

        }

        init() {
            super.init();

        }

        set Code(val) {
            this.items.code.Value = val;
        }
        get Code() {
            return this.items.code.Value;
        }
        set Name(val) {
            this.items.name.Value = val;
        }
        get Name() {
            return this.items.name.Value;
        }

        set Stock(val) {
            this.items.stock.Value = val;
        }
        get Stock() {
            return this.items.stock.Value;
        }
        set Sold(val) {
            this.items.sold.Value = val;
        }
        get Sold() {
            return this.items.sold.Value;
        }
        set Total(val) {
            this.items.total.Value = val;
        }
        get Total() {
            return this.items.total.Value;
        }


    }


    //
    return ImportSearchPanel;
})();


//
module.exports = ImportSearchPanel;
