
var RecordItemBase = require("./RecordItemBase");

// ====

var RecordItem = (function() {
    //

    //
    class RecordItem extends RecordItemBase {
        constructor(parentView, options, data) {
            super(parentView, options, data);
            var _this = this;
            var target;


            // == ui ==


            // == methods ==
            function onTouchStart() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgActive });
                //
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        _this.emit("itemClicked", _this.data);
                    }
                }
            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgActive });
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
            }
            function onClick() {
                if(_this.opts.disabled) return;
                _this.emit("itemClicked", _this.data);//dev
            }

            // == events ==
            if("ontouchstart" in window) {
                this.panel.domOn("touchstart", onTouchStart, false);
                this.panel.domOn("touchmove", onTouchMove, false);
                this.panel.domOn("touchend", onTouchEnd, false);

            } else {
                this.panel.domOn("mousedown", onMouseDown);
                this.panel.domOn("mouseenter", onMouseEnter);
                this.panel.domOn("mouseleave", onMouseLeave);
                this.panel.domOn("mouseup", onMouseUp);
                this.panel.domOn("click", onClick);

            }


            // //
            // this.redraw(true);

        }

        init() {
            super.init();

            this.look.bgColor = BerColor.Mid;
            this.look.txtColor = BerColor.Dark;

            this.look.bgNormal = BerColor.Brighter;
            this.look.bgActive = BerColor.BtnBright;

        }

        redrawLook() {
            super.redrawLook();

            this.panel.setLook({ bgColor: this.look.bgNormal });

        }

    }


    //
    return RecordItem;
})();


//
module.exports = RecordItem;
