
var BerUI = require("../index");

// ====

var LoadingPanel = (function() {
    //

    //
    class LoadingPanel extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==
            this.imgLogo.setLook({ src: this.look.srcLogo });
            this.imgLoading.setLook({ src: this.look.srcLoading });


            // == events ==

        }


        // == init ==
        init() {
            super.init();
            var _this = this;

            this.opts.visible = false;

            //
            this.look.srcLogo = "img/temp.png";
            this.look.srcLoading = "img/sys/loading.gif";


            // == ui ==

            var panel = new BerUI.BasePanel(this, {
                look: {
                    bgColor: "rgba(240, 240, 240, 0.5)"//BerColor.TrasparentDark
                }
            });

            var imgLogo = new BerUI.ImageView(panel);
            var imgLoading = new BerUI.ImageView(panel);

            //
            this.panel = panel;
            this.imgLogo = imgLogo;
            this.imgLoading = imgLoading;


        }


        // ====

        redrawRect() {
            super.redrawRect();

            var SIZE_LOGO = 128;
            var SPACE = 20;
            var SIZE_LOADING = 64;
            var TOTAL_H = SIZE_LOGO + SPACE + SIZE_LOADING;

            this.imgLogo.setRect({
                x: ((this.PxW - SIZE_LOGO) / 2) + "px",
                y: ((this.PxH - TOTAL_H) / 2) + "px",
                w: SIZE_LOGO + "px",
                h: SIZE_LOGO + "px"
            });

            this.imgLoading.setRect({
                x: ((this.PxW - SIZE_LOADING) / 2) + "px",
                y: ((this.PxH - TOTAL_H) / 2 + SIZE_LOGO + SPACE) + "px",
                w: SIZE_LOADING + "px",
                h: SIZE_LOADING + "px"
            });

        }


    }


    //
    return LoadingPanel;
})();


//
module.exports = LoadingPanel;
