
var BerUI = require("../../index");

// ====

var MenuItem = (function() {
    //

    //
    class MenuItem extends BerUI.BasePanel {
        constructor(parentView, options, data) {
            super(parentView, options);
            var _this = this;
            this.data = data;

            // var menuData = {
            //     id: "idid",
            //     name: "NAME NAME",
            //     iconSrc: "img/demo.png";,
            //     txtColor: BerColor.Dark,
            //     bgNormal: BerColor.Brighter,
            //     bgActive: "white",
            //     count: 0,
            // };


            // == ui ==
            // load(data);
            if(isUsable(data)) {
                if(isUsable(data.name)) this.look.name = data.name;
                if(isUsable(data.iconSrc)) this.look.iconSrc = data.iconSrc;
                if(isUsable(data.txtColor)) this.look.txtColor = data.txtColor;
                if(isUsable(data.bgNormal)) this.look.bgNormal = data.bgNormal;
                if(isUsable(data.bgActive)) this.look.bgActive = data.bgActive;
                if(isUsable(data.count)) this.look.count = data.count;
                if(isUsable(data.maskOn)) this.look.maskOn = data.maskOn;
            }


            // == methods ==
            var target;
            function onTouchStart() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgActive });
                //
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        _this.emit("itemClicked", _this.data);
                    }
                }
            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgActive });
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
            }
            function onClick() {
                if(_this.opts.disabled) return;
                _this.emit("itemClicked", _this.data);
            }

            // function load(data) {
            //     _this.data = data;
            //     if(isUsable(data)) {
            //         if(isUsable(data.iconSrc)) _this.look.iconSrc = data.iconSrc;
            //         if(isUsable(data.name)) _this.look.name = data.name;
            //         if(isUsable(data.count)) setMsgCount(data.count);
            //     }
            //     //
            //     _this.canvasIcon.setLook({ src: _this.look.iconSrc });
            //     _this.txtName.setLook({
            //         txtColor: _this.look.txtColor,
            //         txt: _this.look.name
            //     });
            //
            // }
            function setMsgCount(count) {
                _this.data.count = count
                if(count) {
                    _this.txtMsgCount.Value = count;
                    _this.cellMsgCount.show();
                    //
                    _this.redraw(true);

                } else {
                    _this.txtMsgCount.Value = 0;
                    _this.cellMsgCount.hide();

                }
            }

            //
            // this.load = load;
            this.setMsgCount = setMsgCount;


            // == events ==
            if("ontouchstart" in window) {
                this.mask.domOn("touchstart", onTouchStart, false);
                this.mask.domOn("touchmove", onTouchMove, false);
                this.mask.domOn("touchend", onTouchEnd, false);

            } else {
                this.mask.domOn("mousedown", onMouseDown);
                this.mask.domOn("mouseenter", onMouseEnter);
                this.mask.domOn("mouseleave", onMouseLeave);
                this.mask.domOn("mouseup", onMouseUp);
                this.mask.domOn("click", onClick);

            }


            // ====
            this.redraw(true);

        }

        init() {
            super.init();

            // this.look.bgColor = BerColor.Brighter;

            this.look.iconSrc = "";//"img/demo.png";
            this.look.name = "";
            this.look.txtColor = BerColor.Dark;
            this.look.bgNormal = BerColor.Brighter;
            this.look.bgActive = "white";
            this.look.count = 0;
            this.look.maskOn = false;


            // == ui ==
            var panel = new BerUI.BasePanel(this, {
                look: {
                    padding: 16,
                    // bgColor: BerColor.Brighter
                }
            });

            // image
            var cellIcon = new BerUI.BasePanel(panel, {
                rect: { h: 75 },
                look: { padding: 8 }
            });
            var _cellIcon = new BerUI.BasePanel(cellIcon);
            var canvasIcon = new BerUI.CanvasView(_cellIcon);

            // name
            var cellName = new BerUI.BasePanel(panel, {
                rect: { y: 75, h: 25 },
                look: { padding: 2 }
            });
            var txtName = new BerUI.TextView(cellName, {
                look: {
                    txtScale: 0.6,
                    txtAlign: "center"
                }
            });

            // count
            var cellMsgCount = new BerUI.BasePanel(this, {
                opts: { visible: false }
            });
            var txtMsgCount = new BerUI.TextView(cellMsgCount, {
                look: {
                    bgColor: "red",
                    txtColor: "white",
                    txtScale: 0.5,
                    txtAlign: "center"
                },
            });

            //
            var mask = new BerUI.BasePanel(this);


            //
            this.panel = panel;

            this.cellIcon = cellIcon;
            this.cellName = cellName;
            this.cellMsgCount = cellMsgCount;

            this.canvasIcon = canvasIcon;
            this.txtName = txtName;
            this.txtMsgCount = txtMsgCount;
            this.mask = mask;

        }

        redrawRect() {
            super.redrawRect();

            if(this.cellMsgCount.opts.visible) {
                var SPACE = 16;
                var CNT_SIZE = 30;
                this.cellMsgCount.setRect({
                    x: (this.PxW - CNT_SIZE - SPACE) + "px",
                    y: SPACE + "px",
                    w: CNT_SIZE + "px",
                    h: CNT_SIZE + "px"
                });
            }

        }

        redrawLook() {
            super.redrawLook();

            //
            this.panel.setLook({ bgColor: this.look.bgNormal });

            //
            this.canvasIcon.setLook({ src: this.look.iconSrc });

            //
            this.txtName.setLook({
                txtColor: this.look.txtColor,
                txt: this.look.name
            });

            //
            if(this.setMsgCount) this.setMsgCount(this.look.count);
            if(this.cellMsgCount.opts.visible) {
                this.txtMsgCount.setLook({
                    borderRadius: this.txtMsgCount.PxW / 2
                });
            }

            //
            if(this.look.maskOn) {
                this.mask.setLook({
                    bgColor: "rgba(200, 200, 200, 0.5)"
                });
            } else {
                this.mask.setLook({
                    bgColor: BerColor.Trasparent
                });
            }

        }

    }


    //
    return MenuItem;
})();


//
module.exports = MenuItem;
