
var BerUI = require("../index");

// ====

var SimpleBtn = (function() {
    //

    //
    class SimpleBtn extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;
            var target;

            this.txt.setLook({
                bgColor: this.look.bgNormal,
                txtColor: this.look.txtColor,
                txtScale: this.look.txtScale,
                txt: this.look.txt
            });


            // == methods ==
            function onTouchStart() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgActive });
                //
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgNormal });
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgNormal });
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        // _this.circle_inner.setLook({ bgColor: _this.look.bgColor });
                        _this.emit("clicked", _this.data);
                        _this.emit("itemClicked", _this.data);
                    }
                }
            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgActive });
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgNormal }); // TODO add EnterStyle
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgNormal });
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
                _this.txt.setLook({ bgColor: _this.look.bgNormal });
            }
            function onClick() {
                if(_this.opts.disabled) return;
                _this.emit("clicked", _this.data);
                _this.emit("itemClicked", _this.data);
            }


            // == events ==
            if("ontouchstart" in window) {
                this.cell.domOn("touchstart", onTouchStart, false);
                this.cell.domOn("touchmove", onTouchMove, false);
                this.cell.domOn("touchend", onTouchEnd, false);
            } else {
                this.cell.domOn("mousedown", onMouseDown);
                this.cell.domOn("mouseenter", onMouseEnter);
                this.cell.domOn("mouseleave", onMouseLeave);
                this.cell.domOn("mouseup", onMouseUp);
                this.cell.domOn("click", onClick);
            }


            // ====
            // this.redraw(true);


        }


        // == init ==
        init() {
            super.init();

            this.look.bgColor = "rgb(220, 220, 220)";//BerColor.Mid;
            //
            this.look.txtColor = BerColor.BtnBright;//BerColor.Darker;
            this.look.txtScale = 0.4;
            //
            this.look.txt = "";
            this.look.bgNormal = BerColor.Brighter;
            this.look.bgActive = "white";//BerColor.Bright;


            // == ui ==
            var cell = new BerUI.BasePanel(this, {
                // look: { paddingScale: 2 }
            });
            var txt = new BerUI.TextView(cell, {
                look: {
                    txtAlign: "center"
                }
                // opts: { cursor: "pointer" }
            });

            //
            this.cell = cell;
            this.txt = txt;


        }

        //
        redrawLook() {
            super.redrawLook();

            this.txt.setLook({
                bgColor: this.look.bgNormal
            });

        }

        //
        set Value(val) {
            this.txt.Value = val;
        }

    }


    //
    return SimpleBtn;
})();


// ====
module.exports = SimpleBtn;
