
var BerUI = require("../index");

// ====

var SimplePicBtn = (function() {
    //

    //
    class SimplePicBtn extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;
            var target;

            if(isUsable(options.look)) {
                if(isUsable(options.look.imgNormal)) {
                    this.look.imgNormal = options.look.imgNormal;
                    _this.canvas.setLook({ src: _this.look.imgNormal });
                }
                if(isUsable(options.look.imgActive)) this.look.imgActive = options.look.imgActive;
            }


            // == methods ==
            function onTouchStart() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgActive });
                //
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgNormal });
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgNormal });
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        // _this.circle_inner.setLook({ bgColor: _this.look.bgColor });
                        _this.emit("clicked", _this.data);
                        _this.emit("itemClicked", _this.data);
                    }
                }
            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgActive });
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgNormal });
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgNormal });
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
                _this.canvas.setLook({ src: _this.look.imgNormal });
            }
            function onClick() {
                if(_this.opts.disabled) return;
                _this.emit("clicked", _this.data);
                _this.emit("itemClicked", _this.data);
            }


            // == events ==
            if("ontouchstart" in window) {
                this.cell.domOn("touchstart", onTouchStart, false);
                this.cell.domOn("touchmove", onTouchMove, false);
                this.cell.domOn("touchend", onTouchEnd, false);
            } else {
                this.cell.domOn("mousedown", onMouseDown);
                this.cell.domOn("mouseenter", onMouseEnter);
                this.cell.domOn("mouseleave", onMouseLeave);
                this.cell.domOn("mouseup", onMouseUp);
                this.cell.domOn("click", onClick);
            }

            // this.canvas.domOn("mousedown", function() {
            //     _this.canvas.setLook({ src: _this.look.imgActive });
            // });
            // this.canvas.domOn("mouseleave", function() {
            //     _this.canvas.setLook({ src: _this.look.imgNormal });
            // });
            // this.canvas.domOn("mouseup", function() {
            //     _this.canvas.setLook({ src: _this.look.imgNormal });
            //     _this.emit("click");
            // });


            // ====
            this.redraw(true);


        }


        // == init ==
        init() {
            super.init();


            // extends
            this.look.imgNormal = "img/sys/left_light_gray.png";
            this.look.imgActive = "img/sys/left_white.png";


            // == ui ==
            var cell = new BerUI.BasePanel(this);
            var canvas = new BerUI.CanvasView(cell, {
                opts: { cursor: "pointer" }
            });

            //
            this.cell = cell;
            this.canvas = canvas;


        }

        redrawLook() {
            super.redrawLook();

            this.canvas.setLook({ src: this.look.imgNormal });

        }




    }

    //
    return SimplePicBtn;
})();


//
module.exports = SimplePicBtn;
