
var BerUI = require("../index");

// ====

var StarPanel = (function() {
    //
    var CELL_PADDING = 4;

    //
    class StarPanel extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            var starCnt = 1;


            // == ui ==
            reset();


            // == methods ==
            function getValue() {   // TODO 此為舊版, 待處理
                return starCnt;
            }
            function getData() {
                return {
                    stars: starCnt,
                    range: _this.tgbEqual.Value
                };
            }
            function reset() {
                for(var i=0; i<5; i++) {
                    _this.stars[i].setActive(true, "quiet");
                }
                _this.tgbEqual.Value = "≦";
            }
            //
            this.getValue = getValue; // TODO
            this.getData = getData;
            this.reset = reset;


            // == events ==
            this.tgbEqual.on("click", function(btn) {
                if(btn.Value == "≦") {
                    btn.Value = "＝";
                } else if(btn.Value == "＝") {
                    btn.Value = "≧";
                } else if(btn.Value == "≧") {
                    btn.Value = "≦";
                }
            });
            //
            for(var i=0; i<5; i++) {

                (function(I) {

                    _this.stars[I].on("toggle", function(active) {
                        starCnt = I;
                        if(active) {
                            for(var i=0; i<5; i++) {
                                if(i <= I) {
                                    _this.stars[i].setActive(true, "quiet");
                                } else {
                                    _this.stars[i].setActive(false, "quiet");
                                }
                            }

                        } else {
                            for(var i=0; i<5; i++) {
                                if(i > I) {
                                    _this.stars[i].setActive(false, "quiet");
                                } else {
                                    _this.stars[i].setActive(true, "quiet");
                                }
                            }

                        }
                    });

                })(i);

            }

        }


        // == init ==
        init() {
            super.init();

            this.stars = [];

            //
            // this.look.bgColor = BerColor.Dark;
            // this.look.borderRadius = 4;
            this.opts.zIndex = 12;//this.parentView.opts.zIndex + 1;

            // == ui ==

            //
            var cellLeft = new BerUI.BasePanel(this, {
                rect: { w: 100 / 6 * 5 },
                look: { padding: CELL_PADDING }
            });
            var cellStarList = new BerUI.BasePanel(cellLeft, {
                look: {
                    bgColor: BerColor.Dark,
                    borderRadius: 4
                }
            });

            var W = 100 / 5;
            var cellStar, tgbStar;

            for(var i=0; i<5; i++) {
                cellStar = new BerUI.BasePanel(cellStarList, {
                    rect: { x: W*i, w: W },
                    look: { padding: CELL_PADDING }
                });
                tgbStar = new BerUI.ToggleView(cellStar, {
                    look: {
                        txtScale: 0.4,
                        borderRadius: 4,
                        inactive: {
                            bgColor: BerColor.Dark,
                            bgImage: "url('img/sys/star_white.png')"
                        },
                        active: {
                            bgColor: BerColor.Dark,
                            bgImage: "url('img/sys/star_gold.png')"
                        }
                    }
                });
                //
                this.stars.push(tgbStar);
            }


            //
            var cellRight = new BerUI.BasePanel(this, {
                rect: { x: 100 / 6 * 5, w: 100 / 6 },
                look: { padding: CELL_PADDING }
            });
            var cellEqual = new BerUI.BasePanel(cellRight, {
                look: {
                    bgColor: BerColor.Dark,
                    borderRadius: 4
                }
            });
            // var tgbEqual = new BerUI.ToggleView(cellEqual, {
            //     look: {
            //         txtScale: 0.6,
            //         borderRadius: 4,
            //         inactive: {
            //             txtColor: BerColor.Gold,
            //             bgColor: BerColor.Dark,
            //             // bgImage: "url('img/sys/lte.png')",
            //             txt: "≦"
            //         },
            //         active: {
            //             txtColor: BerColor.Gold,
            //             bgColor: BerColor.Dark,
            //             // bgImage: "url('img/sys/eq.png')"
            //             txt: "＝"
            //         }
            //     }
            // });
            var tgbEqual = new BerUI.ButtonView(cellEqual, {
                look: {
                    txtScale: 0.6,
                    borderRadius: 4,
                    bgNormal: BerColor.Dark,
                    bgEnter: BerColor.Dark,
                    bgDown: BerColor.Dark,
                    txtNormal: BerColor.Gold,
                    txtEnter: BerColor.Gold,
                    txtDown: BerColor.Gold,
                    txt: "≦"
                }
            });

            //
            this.tgbEqual = tgbEqual;



        }


        // == redraw ==
        redrawLook() {
            super.redrawLook();

            var bgSize = (this.stars[0].PxW > this.stars[0].PxH) ? (this.stars[0].PxH - CELL_PADDING*2) : (this.stars[0].PxW - CELL_PADDING*2);
            for(var i=0; i<5; i++) {
                this.stars[i].setLook({
                    bgSize: bgSize
                });
            }

            this.tgbEqual.setLook({
                bgSize: bgSize
            });

        }

    }

    //
    return StarPanel;
})();


//
module.exports = StarPanel;
