
var BerUI = require("../../index");
var ItemBase = require("../List/ItemBase");

// ====

var SuggestionItem = (function() {
    //
    var colSettings = [{
        id: "msg",
        type: "text",
        options: {
            look: {
                txtScale: 0.5,
                txtAlign: "left"
            }
        }
    }];
    class SuggestionItem extends ItemBase {
        constructor(parentView, options, data) {
            super(parentView, options, colSettings, data);
            var _this = this;
            var target;


            // == ui ==


            // == methods ==
            function onTouchStart() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgActive });
                _this.items.msg.setLook({ txtColor: _this.look.bgNormal });
                //
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                _this.items.msg.setLook({ txtColor: _this.look.bgActive });
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                _this.items.msg.setLook({ txtColor: _this.look.bgActive });
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        _this.emit("itemClicked", _this.data);
                    }
                }
            }

            function onMouseDown() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgActive });
                _this.items.msg.setLook({ txtColor: _this.look.bgNormal });
            }
            function onMouseEnter() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                _this.items.msg.setLook({ txtColor: _this.look.bgActive });
            }
            function onMouseLeave() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                _this.items.msg.setLook({ txtColor: _this.look.bgActive });
            }
            function onMouseUp() {
                if(_this.opts.disabled) return;
                _this.panel.setLook({ bgColor: _this.look.bgNormal });
                _this.items.msg.setLook({ txtColor: _this.look.bgActive });
            }
            function onClick() {
                if(_this.opts.disabled) return;
                _this.emit("itemClicked", _this.data);//dev
            }

            // == events ==
            if("ontouchstart" in window) {
                this.panel.domOn("touchstart", onTouchStart, false);
                this.panel.domOn("touchmove", onTouchMove, false);
                this.panel.domOn("touchend", onTouchEnd, false);

            } else {
                this.panel.domOn("mousedown", onMouseDown);
                this.panel.domOn("mouseenter", onMouseEnter);
                this.panel.domOn("mouseleave", onMouseLeave);
                this.panel.domOn("mouseup", onMouseUp);
                this.panel.domOn("click", onClick);

            }


            // //
            // this.redraw(true);

        }

        init() {
            super.init();

            this.look.bgColor = "white";//BerColor.Mid;
            // this.look.txtColor = BerColor.Dark;

            this.look.bgNormal = "white";//BerColor.Brighter;
            this.look.bgActive = BerColor.BtnBright;

        }

        redrawLook() {
            super.redrawLook();

            this.panel.setLook({ bgColor: this.look.bgNormal });
            if(this.items && this.items.msg) this.items.msg.setLook({ txtColor: this.look.bgActive });

        }

    }


    //
    return SuggestionItem;
})();


//
module.exports = SuggestionItem;
