
var BerUI = require("../../index");
var ListPanel = require("../List/ListPanel");
var SuggestionItem = require("./SuggestionItem");

// ====

var SuggestionPanel = (function() {
    //

    //
    class SuggestionPanel extends BerUI.BasePanel {
        constructor(parentView, options, data) {
            super(parentView, options);
            var _this = this;
            var target;


            // == ui ==


            // == methods ==
            function onTouchStart() {
                if(_this.opts.disabled) return;
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        onClick();
                    }
                }
            }

            function onClick() {
                if(_this.opts.disabled) return;
                _this.hide();
            }


            // == events ==
            if("ontouchstart" in window) {
                this.closeTrigger.domOn("touchstart", onTouchStart, false);
                this.closeTrigger.domOn("touchmove", onTouchMove, false);
                this.closeTrigger.domOn("touchend", onTouchEnd, false);

            } else {
                this.closeTrigger.domOn("click", onClick);

            }

            this.listPanel.on("itemClicked", function(data) {
                _this.emit("itemClicked", data);
            });

            // this.on("itemClicked", function(data, index) {
            //     console.log(data, index);
            // });


            //
            this.redraw(true);

        }

        init() {
            super.init();

            // this.look.bgColor = BerColor.Brighter;
            this.look.maxRows = 5;

            this.opts.zIndex = 99;

            // this.boxShadow.visible = true;
            // this.boxShadow.blur = 1;
            // this.boxShadow.spread = 1;
            // this.boxShadow.color = BerColor.Mid;

            //
            var listPanel = new ListPanel(this, {
                look: { bgColor: "white" },
                opts: { animate: false }
            }, null, SuggestionItem)

            //
            var closeTrigger = new BerUI.BasePanel(BerRoot, {
                // opts: { visible: "hidden" } // TODO: 參數失效, 待查
                look: {
                    bgColor: BerColor.Trasparent
                }
            });

            //
            this.listPanel = listPanel;
            this.closeTrigger = closeTrigger;


        }

        redrawOpts() {
            super.redrawOpts();

            this.closeTrigger.setOpts({
                zIndex: this.opts.zIndex-1
            });

        }

        show(targetView, data) {
            super.show();

            //
            var refRect = targetView.core.getBoundingClientRect();
            var H = 40;
            var MAX_H = H * this.look.maxRows;
            var targetH = 40 * data.length;
            var h = ((targetH > MAX_H) ? MAX_H : targetH) + this.look.padding * 2;
            this.setRect({
                x: refRect.x + "px",
                y: (refRect.bottom - this.look.padding) + "px",
                w: refRect.width + "px",
                h: h + "px"
            });

            //
            this.listPanel.clear();
            this.listPanel.load(data);
            if(!data || data.length == 0) {
                this.hide();
            } else {
                this.closeTrigger.show();
            }

        }

        hide() {
            super.hide();
            this.closeTrigger.hide();
        }

    }


    //
    return SuggestionPanel;
})();


//
module.exports = SuggestionPanel;
