
var BerUI = require("../index");

// ====

var TextBoxRow = (function() {
    //

    //
    class TextBoxRow extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==
            // this.txtTitle.setLook({ txt: this.look.title });
            // this.tbValue.setLook({
            //     txt: this.look.value,
            //     placeholder: this.look.placeholder
            // });
            // this.tbValue.setOpts({ textType: this.opts.textType });


            // == methods ==
            function reset() {
                _this.tbValue.Value = "";
            }
            function getData() {
                return _this.tbValue.Value;
            }
            function setFrameColor(color) {
                _this.frameValue.setLook({ bgColor: color });
            }
            function focus() {
                _this.tbValue.focus();
            }
            function blur() {
                _this.tbValue.blur();
            }
            function select() {
                _this.tbValue.select();
            }
            //
            this.reset = reset;
            this.getData = getData;
            this.setFrameColor = setFrameColor;
            this.focus = focus;
            this.blur = blur;
            this.select = select;


            // == events ==
            this.tbValue.on("change", function(val) {
                _this.emit("change", val);
            });
            this.tbValue.on("input", function(val) {
                _this.emit("input", val);
            });

            this.tbValue.domOn("focus", function() {
                _this.emit("focus");
            });

        }

        init() {
            super.init();

            this.look.title = "----";
            this.look.value = "";
            this.look.placeholder = "";

            this.opts.textType = "string";
            this.opts.readonly = false;


            // == ui ==

            var cellTitle = new BerUI.BasePanel(this, {
                rect: { h: 30 },
                // look: { paddingScale: 5 }
            });
            var txtTitle = new BerUI.TextView(cellTitle, {
                look: {
                    txtScale: 0.7,
                    txtColor: BerColor.Mid,
                    txtAlign: "left",
                    txt: this.look.title
                }
            });

            var mainPanel = new BerUI.BasePanel(this, { rect: { y: 30, h: 70 } });

            var cellValue = new BerUI.BasePanel(mainPanel, {
                look: { padding: 2 }
            });
            var frameValue = new BerUI.BasePanel(cellValue, {
                look: {
                    padding: 2,
                    bgColor: "white",
                    borderRadius: 4,
                }
            });
            var tbValue = new BerUI.TextBoxView(frameValue, {
                look: {
                    txtAlign: "left",
                    txtScale: 0.4,
                    placeholder: this.look.placeholder
                }
            });


            //
            this.frameValue = frameValue;

            this.txtTitle = txtTitle;
            this.tbValue = tbValue;

        }

        redrawLook() {
            super.redrawLook();

            this.txtTitle.setLook({ txt: this.look.title });
            this.tbValue.setLook({
                txt: this.look.value,
                placeholder: this.look.placeholder
            });

        }

        redrawOpts() {
            super.redrawOpts();

            this.tbValue.setOpts({
                textType: this.opts.textType,
                readonly: this.opts.readonly
            });

        }

        //
        set Title(val) {
            this.look.title = val;
            this.txtTitle.Value = val;
        }
        get Title() {
            return this.txtTitle.Value;
        }

        set Value(val) {
            this.look.value = val;
            this.tbValue.Value = val;
        }
        get Value() {
            return this.tbValue.Value;
        }

    }

    //
    return TextBoxRow;
})();


// ====
module.exports = TextBoxRow;
