
var BerUI = require("../index");

// ====

var TextTextRow = (function() {
    //

    //
    class TextTextRow extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==
            this.txtTitle.setLook({
                txtScale: this.look.titleScale,
                txtAlign: this.look.titleAlign,
                txtColor: this.look.titleColor,
                txt: this.look.title
            });
            this.txtValue.setLook({
                txtScale: this.look.valueScale,
                txtAlign: this.look.valueAlign,
                txtColor: this.look.valueColor,
                txt: this.look.value
            });


            // == methods ==
            function reset() {
                _this.txtValue.Value = "";
            }

            //
            this.reset = reset;


            // == events ==

        }


        // == init ==
        init() {
            super.init();

            this.look.title = "----";
            this.look.value = "----";
            this.look.titleColor = BerColor.Mid;
            this.look.valueColor = BerColor.Darker;
            this.look.titleAlign = "left";
            this.look.valueAlign = "left";
            this.look.titleScale = 0.7;
            this.look.valueScale = 0.4;


            // == ui ==

            var txtTitle = new BerUI.TextView(this, {
                rect: { h: 30 }
            });

            var cellValue = new BerUI.BasePanel(this, {
                rect: { y: 30, h: 70 },
                look: { padding: 2 }
            });
            var txtValue = new BerUI.TextView(cellValue);


            //
            this.txtTitle = txtTitle;
            this.txtValue = txtValue;

        }

        //
        set Title(val) {
            this.txtTitle.Value = val;
        }
        get Title() {
            return this.txtTitle.Value;
        }

        set Value(val) {
            this.txtValue.Value = val;
        }
        get Value() {
            return this.txtValue.Value;
        }


    }

    //
    return TextTextRow;
})();


// ====
module.exports = TextTextRow;
