
var BerUI = require("../index");

// ====

var ToastPanel = (function() {
    //

    //
    class ToastPanel extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == events ==
            this.panel.domOn("click", function() {
                _this.hide();
            });

        }


        // == init ==
        init() {
            super.init();
            var _this = this;

            this.timerHide = new Timer(function() {
                _this.hide();
            }, 1500);


            //
            this.opts.visible = false;


            // == ui ==

            var panel = new BerUI.BasePanel(this, {
                look: {
                    bgColor: BerColor.TrasparentDark
                }
            });

            var txtMsg = new BerUI.TextView(panel, {
                rect: { y: 40, h: 20 },
                look: {
                    txtShadow: {
                        color: "rgba(0, 0, 0, 1)"
                    },
                    txtColor: "rgb(255, 255, 255)",
                    txt: "0",
                    txtScale: 0.5,
                    txtAlign: "center",
                }
            });

            //
            this.panel = panel;
            this.txtMsg = txtMsg;


        }


        // ====

        show(msg) {
            super.show();
            this.txtMsg.setLook({ txt: msg });
            this.redraw(true);
            this.timerHide.start();
        }


    }


    //
    return ToastPanel;
})();


//
module.exports = ToastPanel;
