
var BerUI = require("../index");

// ====

var TriggerPanel = (function() {
    //

    //
    class TriggerPanel extends BerUI.BasePanel {
        constructor(parentView, options, data) {
            super(parentView, options);
            var _this = this;
            var target;


            // == ui ==


            // == methods ==

            function onTouchStart() {
                if(_this.opts.disabled) return;
                target = event.target;
            }
            function onTouchMove() {
                if(_this.opts.disabled) return;
                target = null;
            }
            function onTouchEnd() {
                if(_this.opts.disabled) return;
                //
                var endTarget = document.elementFromPoint(
                    event.changedTouches[0].pageX,
                    event.changedTouches[0].pageY
                );
                if(target === endTarget) {
                    if(event) {
                        // if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        // }
                        onClick();
                    }
                }
            }

            function onClick() {
                if(_this.opts.disabled) return;
                _this.emit("trigger");
            }


            // == events ==
            if("ontouchstart" in window) {
                this.domOn("touchstart", onTouchStart, false);
                this.domOn("touchmove", onTouchMove, false);
                this.domOn("touchend", onTouchEnd, false);

            } else {
                this.domOn("click", onClick);

            }


        }

        init() {
            super.init();

            this.look.bgColor = BerColor.Trasparent;
            this.opts.visible = false;

        }


    }


    //
    return TriggerPanel;
})();


//
module.exports = TriggerPanel;
