
var CoreView = require("../core/CoreView");

// ====

var CanvasView = (function() {
    // // NOTE TODO 這裡的用法錯了, 這會導致不同 instance 用到同個變數 TODO 其他元件待改
    // var _image;

    //
    class CanvasView extends CoreView {
        constructor(parentView, options) {
            super("canvas", parentView, options);
            var _this = this;

            var currentSrc = "";


            // == methods ==

            // NOTE 只公開使用 none 與 auto
            function update(mode) {
                var _image = _this.image;
                var _context2D = _this.core.getContext("2d");

                switch (mode) {
                    case "fit_w": //符合元件寬度, 調整高度以符合比例
                        var viewSize = { w: parentView.PxW, h: parentView.PxH }; // NOTE 直接參考 parentView 的尺寸, 避免自己上次尺寸變動造成基準值不同.

                        var picSize = { w: _image.width, h: _image.height };
                        var newSize = {};
                        newSize.w = viewSize.w;
                        newSize.h = viewSize.w / (picSize.w / picSize.h);

                        // NOTE 若調整完的圖片高度超過元件, 則再做一次高度調整
                        if(newSize.h > viewSize.h) {
                            update("fit_h");
                            break;
                        }

                        _this.setRect({
                            x: (viewSize.w - newSize.w) / 2,
                            y: (viewSize.h - newSize.h) / 2,
                            w: newSize.w,
                            h: newSize.h,
                            mode: "px"
                        });

                        _this.core.width = _image.width;
                        _this.core.height = _image.height;
                        _context2D.drawImage(_image, 0, 0);

                        break;

                    case "fit_h": //符合元件高度, 調整寬度以符合比例
                        var viewSize = { w: parentView.PxW, h: parentView.PxH }; // NOTE 直接參考 parentView 的尺寸, 避免自己上次尺寸變動造成基準值不同.

                        var picSize = { w: _image.width, h: _image.height };
                        var newSize = {};
                        newSize.w = viewSize.h / (picSize.h / picSize.w);
                        newSize.h = viewSize.h;

                        // NOTE 若調整完的圖片寬度超過元件, 則再做一次寬度調整
                        if(newSize.w > viewSize.w) {
                            update("fit_w");
                            break;
                        }

                        _this.setRect({
                            x: (viewSize.w - newSize.w) / 2,
                            y: (viewSize.h - newSize.h) / 2,
                            w: newSize.w,
                            h: newSize.h,
                            mode: "px"
                        });

                        _this.core.width = _image.width;
                        _this.core.height = _image.height;
                        _context2D.drawImage(_image, 0, 0);

                        break;

                    case "auto":
                        if(_image.width >= _image.height) {
                            update("fit_w");
                        } else {
                            update("fit_h");
                        }
                        break;


                    default: // origin
                        _this.core.width = _this.PxW;
                        _this.core.height = _this.PxH;
                        _context2D.drawImage(_image, 0, 0);
                        break;
                }
            }

            function clear() {
                currentSrc = ""; // NOTE: 這會決定是否發出 load 事件, 所以需要重置

                // _this.look.src = "";
                _this.setLook({ src: "" }); // NOTE: 這樣才能改過原本可能在進行中的繪製

                //
                var _context2D = _this.core.getContext("2d");
                _context2D.clearRect(0, 0, _this.core.width, _this.core.height);
            }
            function fillColor(color) {
                var _context2D = _this.core.getContext("2d");
                _context2D.fillStyle = color;
                _context2D.fillRect(0, 0, _this.core.width, _this.core.height);
            }
            //
            this.clear = clear;
            this.fillColor = fillColor;


            // == events ==
            this.image.onload = function() {

                if(currentSrc != _this.look.src) {
                    currentSrc = _this.look.src;
                    _this.emit("load", _this.image.width, _this.image.height);
                }

                update(_this.look.fillMode);

            };
            this.on("redraw", function() {
                update(_this.look.fillMode);
            });

        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.src = "";
            this.look.fillMode = "auto";       // none, fit_w, fit_h, auto >> NOTE 目前只公開使用 none 與 auto

            //
            this.image = new Image();


            // NOTE 若只對原有的物件新增屬性, 就不用再做 setOptions
        }
        // setOptions(options) {
        //     super.init(options);
        // }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.image.src = this.look.src;

        }


        // == getter ==
        get Value() {
            return this.core.value;
        }


    }


    //
    return CanvasView;
})();


//
module.exports = CanvasView;
