
var CoreView = require("../core/CoreView");

// ====

var TextAreaView = (function() {
    //
    var fontSize = 0;

    //
    class TextAreaView extends CoreView {
        constructor(parentView, options) {
            super("textarea", parentView, options);
            var _this = this;

            //
            this.focus = function () {
                _this.core.focus();
            }
            this.blur = function () {
                _this.core.blur();
            }
            this.append = function (msg) {
                _this.core.value += msg;
            }
            this.scrollToBottom = function () {
                _this.core.scrollTop = _this.core.scrollHeight;
            }


            // == events ==
            this.domOn("input", function() {
                _this.look.txt = _this.core.value;
                _this.emit("change", _this.core.value);// TODO: 即將棄用
                _this.emit("input", _this.core.value);
            });


        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.txt = "";
            this.look.txtSize = 0;                      // NOTE 0 時會自動計算文字尺寸. 大於 0 則會以此值為固定尺寸.
            this.look.txtScale = 0.5;                   // NOTE 此值是個比例. 預設值會根據元件高度變動.
            this.look.txtColor = "rgb(255, 255, 255)";
            this.look.txtAlign = "center";              // left, right, center, justify
            this.look.placeholder = "";

            // opts
            this.opts.readonly = false;
            this.opts.resize = "none";                  // none, both, horizontal, vertical

        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.value = this.look.txt;
            this.core.style.color = this.look.txtColor;
            this.core.style.textAlign = this.look.txtAlign;

            if(this.look.txtSize == 0) {
                // 自動
                this.core.style.fontSize = (this.PxH * this.look.txtScale) + "px";
            } else {
                // 定值
                this.core.style.fontSize = this.look.txtSize + "px";
            }

            this.core.placeholder = this.look.placeholder;

        }

        // opts
        redrawOpts() {
            super.redrawOpts();

            if (this.opts.readonly) {
                this.core.setAttribute("readonly", "readonly");
            } else {
                this.core.removeAttribute("readonly");
            }

            this.core.style.resize = this.opts.resize;

        }


        // == getter ==
        get Value() {
            return this.core.value;
        }
        set Value(val) {
            this.look.txt = val;
            this.core.value = val;
        }


    }


    //
    return TextAreaView;
})();


//
module.exports = TextAreaView;
