
var CoreView = require("../core/CoreView");

// ====

// TODO 各種 textType 會需要額外的專屬設定, 例如 number 可以設 min/max.
// ref: https://www.w3schools.com/html/html_form_input_types.asp

var TextBoxView = (function() {
    //

    //
    class TextBoxView extends CoreView {
        constructor(parentView, options) {
            super("text", parentView, options);
            var _this = this;

            //
            this.focus = function () {
                _this.core.focus();
            }
            this.blur = function () {
                _this.core.blur();
            }
            this.select = function() {
                _this.core.select();
            }


            // == events ==
            this.domOn("input", function() {
                _this.look.txt = _this.core.value;
                _this.emit("change", _this.core.value);// TODO: 即將棄用
                _this.emit("input", _this.core.value);
            });

            this.domOn("focus", function() {
                _this.emit("focus");
            });
            this.domOn("blur", function() {
                _this.emit("blur");
            });


        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.txt = "";
            this.look.txtSize = 0;                      // NOTE 0 時會自動計算文字尺寸. 大於 0 則會以此值為固定尺寸.
            this.look.txtScale = 0.5;                   // NOTE 此值是個比例. 預設值會根據元件高度變動.
            this.look.txtColor = "rgb(50, 50, 50)";
            this.look.txtAlign = "center";              // left, right, center, justify
            this.look.placeholder = "";

            // opts
            this.opts.readonly = false;
            this.opts.textType = "text";


        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.value = this.look.txt;
            this.core.style.color = this.look.txtColor;
            this.core.style.textAlign = this.look.txtAlign;

            if(this.look.txtSize == 0) {
                // 自動
                this.core.style.fontSize = (this.PxH * this.look.txtScale) + "px";
            } else {
                // 定值
                this.core.style.fontSize = this.look.txtSize + "px";
            }

            this.core.placeholder = this.look.placeholder;

        }

        // opts
        redrawOpts() {
            super.redrawOpts();

            this.core.type = this.opts.textType;

            if (this.opts.readonly) {
                this.core.setAttribute("readonly", "readonly");
            } else {
                this.core.removeAttribute("readonly");
            }

        }


        // == getter ==
        get Value() {
            return this.core.value;
        }
        set Value(val) {
            this.setLook({ txt: val });
        }

    }


    //
    return TextBoxView;
})();


//
module.exports = TextBoxView;
