
var CoreView = require("../core/CoreView");

// ====

var TextView = (function() {
    //

    //
    class TextView extends CoreView {
        constructor(parentView, options) {
            super("div", parentView, options);
            var _this = this;

        }

        // == init ==
        init(options) {
            super.init();

            //
            this.core.style.overflowX = "hidden";
            this.core.style.overflowY = "hidden";

            // look
            this.look.txt = "";
            this.look.txtSize = 0;                      // NOTE 0 時會自動計算文字尺寸. 大於 0 則會以此值為固定尺寸.
            this.look.txtScale = 0.5;                   // NOTE 此值是個比例. 預設值會根據元件高度變動.
            this.look.txtColor = "rgb(255, 255, 255)";
            this.look.txtAlign = "center";              // left, right, center, justify
            this.look.txtShadow = {
                h: 0,
                v: 0,
                blur: 1,
                color: "rgba(0, 0, 0, 0)"
            };

            // TEMP: test
            this.core.style.fontWeight = "bolder";

        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.innerHTML = this.look.txt;
            this.core.style.color = this.look.txtColor;
            this.core.align = this.look.txtAlign;
            this.core.style.textShadow = this.look.txtShadow.h + "px " + this.look.txtShadow.v + "px " + this.look.txtShadow.blur + "px " + this.look.txtShadow.color;

            if(this.look.txtSize == 0) {
                // 自動
                if(window.BerIsSafari) {
                    this.core.style.fontSize = (this.PxH * this.look.txtScale * 1.6) + "px";
                } else {
                    this.core.style.fontSize = (this.PxH * this.look.txtScale) + "px";
                }

            } else {
                // 定值
                this.core.style.fontSize = this.look.txtSize + "px";
            }

            this.core.style.lineHeight = (this.PxH - this.look.padding*2) + "px";

        }

        //
        get Value() {
            return this.look.txt;
        }
        set Value(val) {
            this.setLook({ txt: val });
        }

    }


    //
    return TextView;
})();


//
module.exports = TextView;
