
var TextView = require("./TextView");

// ====

var ToggleView = (function() {
    //

    //
    class ToggleView extends TextView {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            var active = false;
            var radioIndex = null;
            var radioGroup = null;

            //
            function initRadio(index, group) {
                radioIndex = index;
                radioGroup = group;
            }
            function setActive(act, mode) {
                active = act;
                update(mode);
            }
            function getActive(act) {
                return active;
            }
            function getRadioIndex() {
                return radioIndex;
            }
            function update(mode) {
                if(active) {
                    _this.setLook({
                        bgColor: _this.look.active.bgColor,
                        txtColor: _this.look.active.txtColor,
                        bgImage: _this.look.active.bgImage
                    });
                } else {
                    _this.setLook({
                        bgColor: _this.look.inactive.bgColor,
                        txtColor: _this.look.inactive.txtColor,
                        bgImage: _this.look.inactive.bgImage
                    });
                }

                if(active && radioGroup) {
                    for(var i=0; i<radioGroup.length; i++) {
                        if(radioGroup[i].getRadioIndex() != radioIndex) {
                            radioGroup[i].setActive(false);
                        }
                    }
                }

                // ==
                if(!isUsable(mode) || mode != "quiet") {

                    _this.emit("toggle", active);
                    if(active) {
                        _this.emit("toggleOn");
                    } else {
                        _this.emit("toggleOff");
                    }

                }

            }
            function toggle() {
                if(radioGroup && active) {
                    // 若有設定 radioGroup 且 active, 則不切換狀態
                } else {
                    active = !active;
                    update();
                }
            }
            //
            this.initRadio = initRadio;
            this.setActive = setActive;
            this.getActive = getActive;
            this.getRadioIndex = getRadioIndex;
            this.toggle = toggle;


            // == events ==
            // mouse
            this.domOn("mousedown", function() {
                toggle();
            });

            // touch
            this.domOn("touchstart", function() {
                toggle();
            });


            // ==
            update(); // for init NOTE TODO  not work

        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.inactive = {
                txt: null,
                bgColor: null,
                txtColor: null,
                bgImage: null
            };
            this.look.active = {
                txt: null,
                bgColor: null,
                txtColor: null,
                bgImage: null
            };

            // opts
            this.opts.cursor = "pointer"; // 改預設值, 非新增

        }


        // == redraw ==

        // look
        redrawLook() {
            if(isUsable(this.getActive) && this.getActive()) {
                this.look.txt = this.look.active.txt;
                this.look.bgColor = this.look.active.bgColor;
                this.look.txtColor = this.look.active.txtColor;
                this.look.bgImage = this.look.active.bgImage;
            } else {
                this.look.txt = this.look.inactive.txt;
                this.look.bgColor = this.look.inactive.bgColor;
                this.look.txtColor = this.look.inactive.txtColor;
                this.look.bgImage = this.look.inactive.bgImage;
            }

            //
            super.redrawLook();

        }


    }


    //
    return ToggleView;
})();


//
module.exports = ToggleView;
