
var DivView = require("../basic/DivView");

// ====

var BasePanel = (function() {
    //
    window.BerBasePanelNoAnim = false;

    //
    class BasePanel extends DivView {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;




            // == methods ==
            function isVisibleInDOM() {
                // NOTE: 只要 element 的 parents 的 style 的 display 是 hidden, offsetParent 就會是 null.
                return !(_this.core.offsetParent === null);

                // NOTE: 據說對於 poistion 為 fixed 無效. 若需要處理此狀況, 要使用像是以下的方式
                // function isHidden(el) {
                //     var style = window.getComputedStyle(el);
                //     return (style.display === 'none')
                // }
                //       >> (fixed 再另外處理好了)

            }

            this.isVisibleInDOM = isVisibleInDOM;


            // NOTE: 以下方式雖然可行, 但應該沒必要讓每個元件都呼叫.
            // TODO: 加個參數 callRedrawOnWindowResizeIfVisible 來控制 BasePanel 是否需要在這狀態 redraw.
            // // == events ==
            // window.addEventListener("resize", function () {
            //     if(isVisibleInDOM()) {
            //         console.log("[window resize] visible > redraw");
            //         _this.redraw(true);
            //     }
            // }, false);


        }

        // ====

        show() {
            if(!window.BerBasePanelNoAnim) this.endAnimation();  // NOTE: 避免沒播完的 hide 動畫, 造成最後結果是 hide
            this.setOpts({ visible: true });
        }
        hide() {
            if(window.BerBasePanelNoAnim) {
                this.setOpts({ visible: false });
            } else {
                this.animate({
                    visibility: 0,
                    duration: 250
                });
            }
        }

        slideInFromLeft() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateX: -(this.PxX + this.PxW)
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateX: 0
                },
                // duration: 1000
            }]);
        }
        slideInFromRight() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateX: document.documentElement.offsetWidth + this.PxW
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateX: 0
                },
                // duration: 1000
            }]);
        }
        slideInFromTop() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateY: -(this.PxY + this.PxH)
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateY: 0
                },
                // duration: 1000
            }]);
        }
        slideInFromBottom() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateY: document.documentElement.offsetHeight + this.PxH
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateY: 0
                },
                // duration: 1000
            }]);
        }

        slideOutToLeft() {
            this.animate([{
                transform: {
                    translateX: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateX: -(this.PxX + this.PxW)
                },
                // duration: 1000
            }]);
        }
        slideOutToRight() {
            this.animate([{
                transform: {
                    translateX: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateX: document.documentElement.offsetWidth + this.PxW
                },
                // duration: 1000
            }]);
        }
        slideOutToTop() {
            this.animate([{
                transform: {
                    translateY: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateY: -(this.PxY + this.PxH)
                },
                // duration: 1000
            }]);
        }
        slideOutToBottom() {
            this.animate([{
                transform: {
                    translateY: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateY: document.documentElement.offsetHeight + this.PxH
                },
                // duration: 1000
            }]);
        }

        dispose() {
            this.hide();
            this.removeFromParent();
        }

    }


    //
    return BasePanel;
})();


//
module.exports = BasePanel;
