
// == methods ==

window.isUsable = function(obj) {
    if(typeof(obj) !== "undefined" && obj != null) {
        return true;
    } else {
        return false;
    }
}

window.isNumeric = function(n) {
     return !isNaN(parseFloat(n)) && isFinite(n);
}

window.randomString = function(length, chars) {
    var mask = '';
    if (chars.indexOf('a') > -1) mask += 'abcdefghijklmnopqrstuvwxyz';
    if (chars.indexOf('A') > -1) mask += 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    if (chars.indexOf('#') > -1) mask += '0123456789';
    if (chars.indexOf('!') > -1) mask += '~`!@#$%^&*()_+-={}[]:";\'<>?,./|\\';
    var result = '';
    for (var i = length; i > 0; --i) result += mask[Math.floor(Math.random() * mask.length)];
    return result;
    //
    // console.log(randomString(16, 'aA'));
    // console.log(randomString(32, '#aA'));
    // console.log(randomString(64, '#A!'));
}

window.splitString = function(str, size) {
    //TODO check performance
    var re = new RegExp('.{1,' + size + '}', 'g');
    return str.match(re);
}

window.getUrlParam = function(name) {
    url = window.location.href;
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}

// // Object
// Object.prototype.clone = function() {
//     return Object.assign({}, this);
// }
// Object.prototype.assignToTargetOwnProps = function(target) {
//     // 目標是把 this 的 property 寫進 target, 但不是全部都寫
//     // 只挑 target 也有的 property, 才把值寫進去
//     var props = Object.getOwnPropertyNames(target);
//     var prop;
//     for(k in props) {
//         prop = props[k];
//         if(isUsable(this[prop])) {
//             if(isUsable(target[prop]) && typeof target[prop] === "object") {
//                 this[prop].assignToTargetOwnProps(target[prop]);
//             } else {
//                 target[prop] = this[prop];
//             }
//         }
//     }
// }
window.clone = function(from) {
    return Object.assign({}, from);
}
window.assignToTargetOwnProps = function(from, target) {
    // 目標是把 this 的 property 寫進 target, 但不是全部都寫
    // 只挑 target 也有的 property, 才把值寫進去
    var props = Object.getOwnPropertyNames(target);
    var prop;
    for(k in props) {
        prop = props[k];
        if(isUsable(from[prop])) {
            if(isUsable(target[prop]) && typeof target[prop] === "object") {
                assignToTargetOwnProps(from[prop], target[prop]);
            } else {
                target[prop] = from[prop];
            }
        }
    }
}

window.tryParseJSON = function(str) {
    var obj;
    try {
        obj = JSON.parse(str);
    } catch (e) {
        console.log("[tryParseJSON]", e);
        obj = null;
    }
    return obj;
}

//
String.prototype.startsWith = function (prefix) {
    return (this.substr(0, prefix.length) === prefix);
}
String.prototype.endsWith = function (suffix) {
    return (this.substr(this.length - suffix.length) === suffix);
}
String.prototype.contains = function (txt) {
    return (this.indexOf(txt) >= 0);
}
String.prototype.paddingLeft = function (paddingValue) {
    return String(paddingValue + this).slice(-paddingValue.length);
};
String.prototype.splitTrim = function(sep) {
    var arr = this.split(sep);
    for(i=0; i<arr.length; i++) {
        arr[i] = arr[i].trim();
    }
    return arr;
}

//
Date.prototype.addYears = function(years, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setFullYear(date.getFullYear() + years);
        return date;

    } else {
        this.setFullYear(this.getFullYear() + years);
        return this;

    }

}
Date.prototype.addMonths = function(months, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setMonth(date.getMonth() + months);
        return date;

    } else {
        this.setMonth(this.getMonth() + months);
        return this;

    }

}
Date.prototype.addDays = function(days, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setDate(date.getDate() + days);
        return date;

    } else {
        this.setDate(this.getDate() + days);
        return this;

    }

}
Date.prototype.addHours = function(hours, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setHours(date.getHours() + hours);
        return date;

    } else {
        this.setHours(this.getHours() + hours);
        return this;

    }

}
Date.prototype.addMinutes = function(minutes, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setMinutes(date.getMinutes() + minutes);
        return date;

    } else {
        this.setMinutes(this.getMinutes() + minutes);
        return this;

    }

}
Date.prototype.toYYYYMMdd = function() {
    return this.getFullYear().toString() + "/" + (this.getMonth() + 1).toString().paddingLeft('00') + "/" + this.getDate().toString().paddingLeft('00');
}
Date.prototype.toYYYYMM = function() {
    return this.getFullYear().toString() + "/" + (this.getMonth() + 1).toString().paddingLeft('00');
}
Date.prototype.toHHmm = function() {
    return this.getHours().toString().paddingLeft('00') + ":" + this.getMinutes().toString().paddingLeft('00');
}
Date.prototype.toMMddHHmm = function() {
    return (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00') + " " + this.getHours().toString().paddingLeft('00') + ':' + this.getMinutes().toString().paddingLeft('00');
}
Date.prototype.toMMddHHmmss = function() {
    return (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00') + " " + this.getHours().toString().paddingLeft('00') + ':' + this.getMinutes().toString().paddingLeft('00') + ':' + this.getSeconds().toString().paddingLeft('00');
}
Date.prototype.toMMdd = function() {
    return (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00');
}
Date.prototype.toYYYYMMddHHmm = function() {
    return this.getFullYear().toString() + "/" + (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00') + " " + this.getHours().toString().paddingLeft('00') + ':' + this.getMinutes().toString().paddingLeft('00');
}
Date.prototype.toDay = function() {
    switch(this.getDay()) {
        case 0:
            return "週日";
        case 1:
            return "週一";
        case 2:
            return "週二";
        case 3:
            return "週三";
        case 4:
            return "週四";
        case 5:
            return "週五";
        case 6:
            return "週六";
    }
}

// == Timer ==
window.Timer = function(func, delay) {
    var handle = null;
    var _func = func;
    var _delay = delay;

    function start(newDelay) {
        if (typeof newDelay !== "undefined") {
            _delay = newDelay;
        }
        stop();
        handle = setTimeout(_func, _delay);
    }
    function stop() {
        if (handle) {
            clearTimeout(handle);
            handle = null;
        }
    }

    this.start = start;
    this.stop = stop;

}
window.Looper = function(func, interval) {
    var handle = null;
    var _func = func;
    var _interval = interval;

    function start(newInterval) {
        if (typeof newInterval !== "undefined") {
            _interval = newInterval;
        }
        stop();
        handle = setInterval(_func, _interval);
    }
    function stop() {
        if (handle) {
            clearInterval(handle);
            handle = null;
        }
    }

    this.start = start;
    this.stop = stop;

}

//
window.QueryString = function () {
    // This function is anonymous, is executed immediately and
    // the return value is assigned to QueryString!
    var query_string = {};
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i=0;i<vars.length;i++) {
        var pair = vars[i].split("=");
            // If first entry with this name
        if (typeof query_string[pair[0]] === "undefined") {
          query_string[pair[0]] = decodeURIComponent(pair[1]);
            // If second entry with this name
        } else if (typeof query_string[pair[0]] === "string") {
          var arr = [ query_string[pair[0]],decodeURIComponent(pair[1]) ];
          query_string[pair[0]] = arr;
            // If third or later entry with this name
        } else {
          query_string[pair[0]].push(decodeURIComponent(pair[1]));
        }
    }
    return query_string;
}();
