
require("./global");

var RootView = require('../../../basic/RootView');
var ButtonView = require('../../../basic/ButtonView');
var BasePanel = require("../../BasePanel");

// ====

var root = new RootView();


var cellResidency = new BasePanel(root, {
    rect: { w: 50 },
    look: { padding: 1 }
});
var btnResidency = new ButtonView(cellResidency, {
    look: {
        txtScale: 0.4,
        borderRadius: 4,
        bgNormal: "rgb(56, 147, 170)",
        bgEnter: "rgb(200, 200, 200)",
        bgDown: "rgb(100, 100, 100)",
        txtNormal: "rgb(240, 240, 240)",
        txtEnter: "rgb(100, 100, 100)",
        txtDown: "rgb(200, 200, 200)",
        txt: "Residency"
    }
});

setTimeout(function() {
    btnResidency.animate([{
        bgColor: "rgb(255, 215, 0)",
        transform: {
            scale: 1.5
        },
        duration: 150
    },{
        bgColor: "rgb(240, 240, 240)",
        transform: {
            scale: 1
        },
        duration: 200
    },]);
}, 1000)
