
require("./global");

var RootView = require('../../../basic/RootView');
// var GenericPicker = require('../../GenericPicker');
// var Slider = require("../../Slider");
// var Calendar = require("../../CalendarNightSelector");

var BasePanel = require("../../BasePanel");
var VideoView = require('../../../basic/VideoView');
var CanvasVideoView = require('../../../basic/CanvasVideoView');

// ====

var root = new RootView();
var videoView = new VideoView(root, {
    rect: { h: 50 },
    // look: { src: "video/BigBuckBunny_320x180.mp4" }
});

var canvasCell = new BasePanel(root, {
    rect: { y: 50, h: 50 }
});
var canvasView = new CanvasVideoView(canvasCell, {
    opts: { video: videoView }
});
// canvasView.on("frame", function(dataURL) {
//     console.log(dataURL);
//     canvasView.stop();
// });
// canvasView.start();



// ====

var videoStream = null;
// Test browser support
window.navigator = window.navigator || {};
navigator.getUserMedia = navigator.getUserMedia       ||
                         navigator.webkitGetUserMedia ||
                         navigator.mozGetUserMedia    ||
                         null;
if (navigator.getUserMedia === null) {
   console.log("GG getUserMedia GG");
} else {
   // Opera <= 12.16 accepts the direct stream.
   // More on this here: http://dev.opera.com/articles/view/playing-with-html5-video-and-getusermedia-support/
   var createSrc = window.URL ? window.URL.createObjectURL : function(stream) {return stream;};
   // Opera <= 12.16 supports video only.
   var audioContext = window.AudioContext       ||
                      window.webkitAudioContext ||
                      null;
   if (audioContext === null) {
      console.log("GG audioContext GG");
   }


   videoView.domOn("click", function() {
       navigator.getUserMedia({
          video: true,
          audio: true
       },
       function(stream) {
          videoStream = stream;
          videoView.setLook({ src: createSrc(stream) });
          videoView.play();
          canvasView.start();
       },
       function(error) {
          console.log('Video capture error: ' + error.code);
       });
   });
   canvasView.domOn("click", function() {
       videoView.pause();
       videoStream.stop();
       canvasView.stop();
   });

}




// NOTE 測試完畢, 只要再包成一個完整元件, 就可以放到 face-nec 使用了




















// var calendar = new Calendar(root, {
//     rect: {
//         constW: 350,
//         constH: 375,
//     }
// });
// calendar.setDate(2018, 2);
// calendar.setNights(3);
// calendar.show();

// var nights = 5;
// function selectNights(date) {
//     calendar.clearActiveDates();
//     //
//     var newActiveDates = [date];
//     for(var i=1; i<nights; i++) {
//         newActiveDates.push(date.addDays(i));
//     }
//     calendar.loadActiveDates(newActiveDates);
// }
//
// calendar.on("dateSelected", selectNights);
// calendar.on("dateUnselected", selectNights);



// //
//
// var picker;
//
// function initPicker() {
//     picker = new GenericPicker(root, {
//         rect: {
//             box: { w: 50, h: 50 }
//         },
//         look: {
//             rowNum: 2,
//             colNum: 2,
//             itemTxtScale: 0.2,
//             box: {
//                 // overflowX: "scroll",
//                 overflowY: "scroll"
//             }
//         }
//     }, [
//         { name: "AAA" },
//         { name: "BBB" },
//         { name: "CCC" },
//         { name: "DDD" },
//         { name: "EEE" },
//     ]);
//
//     picker.on("itemClicked", function(item) {
//         console.log(item);
//     });
//
// }
//
// function showPicker() {
//     if(!picker) initPicker();
//     picker.show();
// }
// //
// showPicker();

// ====
// var slider = new Slider(root, {
//     look: {
//         bgColorBack: "red",
//         bgColorFront: "blue",
//         bgColorIndicator: "green"
//     },
//     opts: {
//         max: 999,
//         min: 87
//     }
// });
//
// slider.on("change", function(val) {
//     console.log(val);
// });
